VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} fpvt 
   Caption         =   "Forecast Adjustment"
   ClientHeight    =   7260
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   16140
   OleObjectBlob   =   "fpvt.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "fpvt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public mod_adjust As Boolean
Private month() As Variant
Private mload() As Variant
Option Explicit

Private Sub cbCancel_Click()

    tbAdjVol.value = 0
    tbAdjVal.value = 0
    tbAdjPrice.value = 0
    fpvt.Hide

End Sub



Private Sub cbOK_Click()

    'MsgBox (handler.scenario)
    

End Sub

Private Sub chbPlug_Change()

        opvolume.Enabled = Not chbPlug.value
        opprice.Enabled = Not chbPlug.value

End Sub


Private Sub lbMonth_Change()
    
    Dim i As Long
    For i = 0 To 12
        If lbMonth.Selected(i) Then
            If i <> 0 Then
                '------------base-------------------------------------
                tbMBaseVal.value = co_num(month(i, 6), 0)
                tbMBaseVol.value = co_num(month(i, 2), 0)
                tbmPAVal.value = co_num(month(i, 7), 0)
                tbMPAVol.value = co_num(month(i, 3), 0)
                tbMFVal.value = co_num(month(i, 8), 0)
                tbMFVol.value = co_num(month(i, 4), 0)
                If tbMBaseVol <> 0 Then
                    tbMBasePrice = Format(tbMBaseVal / tbMBaseVol, "#.000")
                Else
                    tbMBasePrice = 0
                End If
                If tbMFVol <> 0 Then
                    tbMFPrice = Format(tbMFVal / tbMFVol, "#.000")
                Else
                    tbMFPrice = 0
                End If
            Else
                tbMBaseVal.value = 0
                tbMBaseVol.value = 0
                tbmPAVal.value = 0
                tbMPAVol.value = 0
                tbMFVal.value = 0
                tbMFVol.value = 0
                tbMBasePrice = 0
                tbMFPrice = 0
            End If
            Exit For
        End If
    Next i
    
    
    
End Sub


Private Sub ListBox1_Click()

End Sub

Private Sub opmprice_Click()
    
    tbMFVal = Format(CDbl(tbmPAVal.value) + CDbl(tbMBaseVal.value) + CDbl(tbMAVal.value), "#,###")
    tbMFVol = Format((CDbl(tbMPAVol.value) + CDbl(tbMBaseVol.value)), "#,###")
    tbMFPrice = Format(CDbl(tbMFVal.value) / CDbl(tbMFVol.value), "#.000")
    
End Sub

Private Sub opmvol_Click()

    Dim pchange As Double

    '---------calculate percent change----------------------------------------------------------------------
    pchange = 1 + CDbl(tbMAVal.value) / (CDbl(tbmPAVal.value) + CDbl(tbMBaseVal.value))
    '---------add the adjustments together to get the new forecast------------------------------------------
    tbMFVal = Format(CDbl(tbmPAVal.value) + CDbl(tbMBaseVal.value) + CDbl(tbMAVal.value), "#,###")
    tbMFVol = Format((CDbl(tbMPAVol.value) + CDbl(tbMBaseVol.value)) * pchange, "#,###")
    tbMFPrice = Format(CDbl(tbMFVal.value) / CDbl(tbMFVol.value), "#.000")

End Sub

Private Sub opprice_Click()

    tbFcVal = Format(CDbl(tbPadjVal.value) + CDbl(tbBaseVal.value) + CDbl(tbAdjVal.value), "#,###")
    tbFcVol = Format((CDbl(tbPadjVol.value) + CDbl(tbBaseVol.value)), "#,###")
    tbFcPrice = Format(CDbl(tbFcVal.value) / CDbl(tbFcVol.value), "#.000")
    
End Sub

Private Sub opvolume_Click()

    Dim pchange As Double

    '---------calculate percent change----------------------------------------------------------------------
    pchange = 1 + CDbl(tbAdjVal.value) / (CDbl(tbPadjVal.value) + CDbl(tbBaseVal.value))
    '---------add the adjustments together to get the new forecast------------------------------------------
    tbFcVal = Format(CDbl(tbPadjVal.value) + CDbl(tbBaseVal.value) + CDbl(tbAdjVal.value), "#,###")
    tbFcVol = Format((CDbl(tbPadjVol.value) + CDbl(tbBaseVol.value)) * pchange, "#,###")
    tbFcPrice = Format(CDbl(tbFcVal.value) / CDbl(tbFcVol.value), "#.000")

End Sub

Private Sub tbAdjVal_Change()
    
    Dim pchange As Double
    
    If IsNumeric(tbAdjVal.value) Then
        '---------calculate percent change----------------------------------------------------------------------
        pchange = 1 + CDbl(tbAdjVal.value) / (CDbl(tbPadjVal.value) + CDbl(tbBaseVal.value))
        '---------add the adjustments together to get the new forecast------------------------------------------
        tbFcVal = Format(CDbl(tbPadjVal.value) + CDbl(tbBaseVal.value) + CDbl(tbAdjVal.value), "#,###")
        '---------if volume adjustment method is selected, scale the volume up----------------------------------
        If opvolume Then
            tbFcVol = Format((CDbl(tbPadjVol.value) + CDbl(tbBaseVol.value)) * pchange, "#,###")
        Else
            tbFcVol = Format((CDbl(tbPadjVol.value) + CDbl(tbBaseVol.value)), "#,###")
        End If
        tbFcPrice = Format(CDbl(tbFcVal.value) / CDbl(tbFcVol.value), "#.000")
    Else
        tbFcVal = Format(CDbl(tbPadjVal.value) + CDbl(tbBaseVal.value), "#,###")
        tbFcVol = Format((CDbl(tbPadjVol.value) + CDbl(tbBaseVol.value)), "#,###")
        tbFcPrice = Format(CDbl(tbFcVal.value) / CDbl(tbFcVol.value), "#.000")
    End If

End Sub


Private Sub tbAdjVol_Change()
    
    If IsNumeric(tbAdjVol.value) Then
        tbFcVol = Format(CDbl(tbAdjVol.value) + CDbl(tbBaseVol.value), "#,###")
    Else
        tbFcVol = Format(CDbl(tbBaseVol.value), "#,###")
    End If

End Sub

Private Sub tbMAVal_Change()

    Dim pchange As Double
    
    If IsNumeric(tbMAVal.value) Then
        '---------calculate percent change----------------------------------------------------------------------
        pchange = 1 + CDbl(tbMAVal.value) / (CDbl(tbMAVal.value) + CDbl(tbMBaseVal.value))
        '---------add the adjustments together to get the new forecast------------------------------------------
        tbMFVal = Format(CDbl(tbmPAVal.value) + CDbl(tbMBaseVal.value) + CDbl(tbMAVal.value), "#,###")
        '---------if volume adjustment method is selected, scale the volume up----------------------------------
        If opmvol Then
            tbMFVol = Format((CDbl(tbMPAVol.value) + CDbl(tbMBaseVol.value)) * pchange, "#,###")
        Else
            tbMFVol = Format((CDbl(tbMPAVol.value) + CDbl(tbMBaseVol.value)), "#,###")
        End If
        tbMFPrice = Format(CDbl(tbMFVal.value) / CDbl(tbMFVol.value), "#.000")
    Else
        tbMFVal = Format(CDbl(tbmPAVal.value) + CDbl(tbMBaseVal.value), "#,###")
        tbMFVol = Format((CDbl(tbMPAVol.value) + CDbl(tbMBaseVol.value)), "#,###")
        tbMFPrice = Format(CDbl(tbMFVal.value) / CDbl(tbMFVol.value), "#.000")
    End If

End Sub

Private Sub UserForm_Activate()
    
    Dim sp As Object
    Dim i As Long
    Dim j As Long
    Dim k As Long
    Dim ok As Boolean
    
    handler.server = "http://10.56.1.20:3000"
    'handler.server = "http://192.168.1.69:3000"

    Set sp = handler.scenario_package(handler.scenario, ok)
    
    If Not ok Then
        fpvt.Hide
        Application.StatusBar = False
        Exit Sub
    End If
    
    
    '---show existing adjustment if there is one----
    fpvt.mod_adjust = False
    
    For i = 1 To sp("package")("totals").Count
        Select Case sp("package")("totals")(i)("order_season")
            Case 2020
                Select Case sp("package")("totals")(i)("iter")
                    Case "copy"
                        fpvt.tbBaseVol.Text = Format(sp("package")("totals")(i)("units"), "#,###")
                        fpvt.tbBaseVal.Text = Format(sp("package")("totals")(i)("value_usd"), "#,###")
                        If sp("package")("totals")(i)("units") <> 0 Then fpvt.tbBasePrice.Text = Format(sp("package")("totals")(i)("value_usd") / sp("package")("totals")(i)("units"), "#.000")
                        
                    Case "adjustment"
                        fpvt.tbPadjVol.Text = Format(sp("package")("totals")(i)("units"), "#,###")
                        fpvt.tbPadjVal.Text = Format(sp("package")("totals")(i)("value_usd"), "#,###")

                End Select
        End Select
    Next i
    
    fpvt.tbFcVol.value = Format(CDbl(fpvt.tbBaseVol.value) + CDbl(fpvt.tbPadjVol.value), "#,###")
    fpvt.tbFcVal.value = Format(CDbl(fpvt.tbBaseVal.value) + CDbl(fpvt.tbPadjVal.value), "#,###")
    fpvt.tbFcPrice.value = Format(CDbl(fpvt.tbFcVal.value) / CDbl(fpvt.tbFcVol.value), "#.000")
    
    '---------------------------------------populate monthly-------------------------------------------------------
    
    k = 0
    '--parse json into variant array for loading--
    ReDim month(sp("package")("mpvt").Count, 8)
        
    For i = 1 To sp("package")("mpvt").Count
        month(i, 0) = sp("package")("mpvt")(i)("order_month")
        month(i, 1) = Format(sp("package")("mpvt")(i)("2019 qty"), "#,###")
        month(i, 2) = Format(sp("package")("mpvt")(i)("2020 base qty"), "#,###")
        month(i, 3) = Format(sp("package")("mpvt")(i)("2020 adj qty"), "#,###")
        month(i, 4) = Format(sp("package")("mpvt")(i)("2020 tot qty"), "#,###")
        month(i, 5) = Format(sp("package")("mpvt")(i)("2019 value_usd"), "#,###")
        month(i, 6) = Format(sp("package")("mpvt")(i)("2020 base value_usd"), "#,###")
        month(i, 7) = Format(sp("package")("mpvt")(i)("2020 adj value_usd"), "#,###")
        month(i, 8) = Format(sp("package")("mpvt")(i)("2020 tot value_usd"), "#,###")
        
    Next i
    
    
    month(0, 0) = "month"
    month(0, 1) = "2019 qty"
    month(0, 2) = "2020 base qty"
    month(0, 3) = "2020 adj qty"
    month(0, 4) = "2020 qty"
    month(0, 5) = "2019 val"
    month(0, 6) = "2020 base val"
    month(0, 7) = "2020 adj val"
    month(0, 8) = "2020 val"
    
    ReDim mload(UBound(month, 1), 5)
    For i = 0 To UBound(month, 1)
        mload(i, 0) = month(i, 0)
        mload(i, 1) = month(i, 1)
        mload(i, 2) = month(i, 4)
        mload(i, 3) = month(i, 5)
        mload(i, 4) = month(i, 8)
    Next i
    
    lbMonth.list = mload
    lbMonth.ColumnCount = 8
    
    'MsgBox (lbMonth.list(0, 0))
     
    Application.StatusBar = False
    
End Sub

Function co_num(ByRef one As Variant, ByRef two As Variant) As Variant

    If one = "" Or IsNull(one) Then
        co_num = two
    Else
        co_num = one
    End If

End Function

